#!/usr/bin/python2.3
#
# MISCLIB -
# Ten floors, I'm falling, guess who I'm recalling? 
# Oh yeah, it's true, my life begins and ends with you.
#

# code by nd (nd@felinemenace.org) and other misc src's

# this is a seperate module and will be used in
# alot more stuff of mine.
# anyway, handy method, whatEVER it is that is used more
# than once in any code should be added. the law has been laid.
class misclib:
	# handy..
	def intel_order(self,myint):
    		str=""
		a=chr(myint % 256)
		myint=myint >> 8
		b=chr(myint % 256)
		myint=myint >> 8
		c=chr(myint % 256)
		myint=myint >> 8
		d=chr(myint % 256)
		str+="%c%c%c%c" % (a,b,c,d)
		return str

	def intel_byte(self,myint):
		#used to make negative numbers work as a byte
		if myint<0:
			tmp=chr(256-abs(myint))
		else:
			tmp=chr(myint)
		return tmp

	# same as struct.pack('H',x)
	def intel_2byte(self,myint):
		#used to do 2 byte "words"
		a=chr(myint % 256)
		myint=myint >> 8
		b=chr(myint % 256)
		str="%c%c"%(a,b)
		return str
	
	# reverses a string, not an array
	# i find it pretty handy.
	def reverse(self,data):
		rev = []
		for x in data:
			rev.append(x)
		rev.reverse()
		data = ""
		for x in rev:
			data += x
		return data

	#convert a string to a set of words which
	#can be used when pushing it onto the stack.
	#'ie, "/bin//sh" becomes 0x68732f2f and 0x6e69622f
	def str2word(self,data):
		# has to be aligned on 4 byte boundary
		if len(data) % 4 != 0:
			print "can't be a word!"
			return ""
		# little endian...
		data = self.reverse(data)
		t = []
		i = "0x"
		size = len(data)
		l = 0
		for x in data:
			if len(i) == 10:
				t.append(i)
				i = "0x"
			# hex fmt
			i += "%2.2x" % ord(x)
			l += 1
			if l == size:
				t.append(i)
		return t
	
	# makes an array of hex from a string
	def make_hex(self,data):
		a = []
		for x in data:
			a.append(ord(x))
		return a
	
	# i use this alot, tests if it is an integer of any sort
	# if it is already passed an int, it returns it anyway.
	def isint(self,test):
		try:
			# izanint?
			x = int(test,0)
			return x
		except ValueError:
			return 0
		# already an int. pointless
		except TypeError:
			return test
	
	# simple but handy
	def hex2num(self,num):
		print "%d" % num
		return "%d" % num
	
	# creats a string from binary data
	# like ethereal packet dumps..etc..
	def binstring(self,data):
		bad = ["\x20","\x0a","\x0d","}",";",","]
		for g in bad:
			data = data.replace(g,"")
		p = ""
		while data != "":
			x = data[:2]
			if x != "\\x" and x != "0x":
				p += chr(int(x,16))
			data = data[2:] 		
		return p
	
	# return some reasonably fmtd data...
	# ie, fix up chaos that the newline and the return will cause
	def fixup(self,data):
		buf = ""
		chars = "!@#$%^&*()_-,.<>?/'\"[]{}:;+=~` " 
		for x in data:
			if x.isalnum():
				buf += x
			elif x == "\r":
				buf += "\\r"
			elif x == "\n":
				buf += "\\n"
				#buf += "\n"
			elif x in chars:
				buf += x
			else:
				buf += "."
		return buf
	
	def hex(self,data):
		buf = ""
		for x in data:
			buf += "\\x%2.2x" % ord(x)
		return buf

# some tests to make sure everything works hunky dory
if __name__ == '__main__':
	x = misclib()
	print x.intel_order(0xbfbf9080)
	for t in x.make_binary("/bin//sh"):
		print t
	# you can make the data as horiible as you want!
	print x.binstring("0x41    \x41 41 41 41 41 41 41 42")